;-| Button Remapping |-----------------------------------------------------
; This section lets you remap the player's buttons (to easily change the
; button configuration). The format is:
;   old_button = new_button
; If new_button is left blank, the button cannot be pressed.
[Remap]
x = x
y = y
z = z
a = a
b = b
c = c
s = s

;-| Default Values |-------------------------------------------------------
[Defaults]
; Default value for the "time" parameter of a Command. Minimum 1.
command.time = 15

; Default value for the "buffer.time" parameter of a Command. Minimum 1,
; maximum 30.
command.buffer.time = 1

;-| Super Motions |--------------------------------------------------------
[Command]
name = "SakuraBomb3"
command = ~D, DF, F, D, DF, F, x
time = 20

[Command]
name = "SakuraBomb3"
command = ~D, DF, F, D, DF, F, y
time = 20

[Command]
name = "SakuraBombR"
command = ~D, DB, B, D, DB, B, x
time = 20

[Command]
name = "SakuraBombR"
command = ~D, DB, B, D, DB, B, y
time = 20

[Command]
name = "SakuraBLAST"   
command = ~F, B, DB, D, DF, F, x+y
time = 30

[Command]
name = "SakuraBLAST"   
command = ~F, B, D, F, x+y
time = 20

[Command]
name = "SakuraBLAST"   
command = ~s
time = 30

[Command]
name = "SakuraBLASTRelease"   
command = /x+y
time = 30

;-| Special Motions |------------------------------------------------------

[Command]
name = "blocking"
command = $F,x
time = 3

[Command]
name = "blocking" ;Same name as above (buttons in opposite order)
command = x,$F
time = 3

;-----------------

[Command]
name = "EX Sakura Rushdown"
command = ~D, DF, F, a+b

[Command]
name = "Light Sakura Rushdown"
command = ~D, DF, F, a

[Command]
name = "Heavy Sakura Rushdown"
command = ~D, DF, F, b

;-----------------

[Command]
name = "upper_x"
command = ~F, D, DF, x

[Command]
name = "upper_y"
command = ~F, D, DF, y

[Command]
name = "upper_xy"
command = ~F, D, DF, x+y

;-----------------
[Command]
name = "QCF_x"
command = ~D, DF, F, x

[Command]
name = "QCF_y"
command = ~D, DF, F, y

[Command]
name = "QCF_xy"
command = ~D, DF, F, x+y

;-----------------
[Command]
name = "QCB_x"
command = ~D, DB, B, x

[Command]
name = "QCB_y"
command = ~D, DB, B, y

[Command]
name = "QCB_xy"
command = ~D, DB, B, x+y

;-----------------
[Command]
name = "QCB_a"
command = ~D, DB, B, a

[Command]
name = "QCB_b"
command = ~D, DB, B, b

[Command]
name = "QCB_ab"
command = ~D, DB, B, a+b


;-| Double Tap |-----------------------------------------------------------
[Command]
name = "FF"     ;Required (do not remove)
command = F, F
time = 10

[Command]
name = "BB"     ;Required (do not remove)
command = B, B
time = 10

;-| 2/3 Button Combination |-----------------------------------------------

[Command]
name = "Aura Awaken"
command = x+b
time = 1

[Command]
name = "Roll"
command = a+x
time = 1

[Command]
name = "Roll"
command = c
time = 1

[Command]
name = "recovery"
command = x+a
time = 1

[Command]
name = "recovery"
command = c
time = 1

;-| Dir + Button |---------------------------------------------------------
[Command]
name = "down_a"
command = /$D,a
time = 1

[Command]
name = "down_b"
command = /$D,b
time = 1

;-| Single Button |---------------------------------------------------------
[Command]
name = "a"
command = a
time = 1

[Command]
name = "b"
command = b
time = 1

[Command]
name = "c"
command = c
time = 1

[Command]
name = "x"
command = x
time = 1

[Command]
name = "y"
command = y
time = 1

[Command]
name = "z"
command = z
time = 1

[Command]
name = "start"
command = s
time = 1

;-| Hold Dir |--------------------------------------------------------------
[Command]
name = "holdfwd";Required (do not remove)
command = /$F
time = 1

[Command]
name = "holdback";Required (do not remove)
command = /$B
time = 1

[Command]
name = "holdup" ;Required (do not remove)
command = /$U
time = 1

[Command]
name = "holddown";Required (do not remove)
command = /$D
time = 1

[Statedef -1]
;===========================================================================

[state -1, DiminuirDanoCombos]
type = attackmulset
trigger1 = numtarget >= 1 && EnemyNear,GethitVar(hitcount) > 3
value = .96 ** target, gethitvar(hitcount)

[State -1, Sakura BLAST]
type = ChangeState
value = 3200
triggerall = command = "SakuraBLAST"
triggerall = power >= 3000
triggerall = statetype != A
trigger1 = ctrl
trigger2 = hitdefattr = SC, NA, SA, HA
trigger2 = stateno != [3050,3100)
trigger2 = movecontact
trigger3 = stateno = 131 || stateno = 130 ;From blocking


[State -1, Sakura Bomb Trilogy]
type = ChangeState
value = 3000
triggerall = command = "SakuraBomb3"
triggerall = power >= 1000
trigger1 = statetype = S
trigger1 = ctrl
trigger2 = statetype != A
trigger2 = hitdefattr = SC, NA, SA, HA
trigger2 = stateno != [3000,3050)
trigger2 = movecontact
trigger3 = stateno = 131 || stateno = 130 ;From blocking

[State -1, Sakura Bomb Remake]
type = ChangeState
value = 3100
triggerall = command = "SakuraBombR"
triggerall = power >= 1000
triggerall = statetype != A
trigger1 = P2Stateno != [5249,5253]
trigger1 = ctrl
trigger2 = hitdefattr = SC, NA, SA, HA
trigger2 = stateno != [3000,3050)
trigger2 = movecontact
trigger3 = stateno = 131 || stateno = 130 ;From blocking

;===========================================================================
;This is not a move, but it sets up var(1) to be 1 if conditions are right
;for a combo into a special move (used below).
;Since a lot of special moves rely on the same conditions, this reduces
;redundant logic.
[State -1, Combo condition Reset]
type = VarSet
trigger1 = 1
var(1) = 0

[State -1, Combo condition Check]
type = VarSet
trigger1 = statetype != A
trigger1 = ctrl
trigger1 = roundstate = 2
trigger2 = (stateno = [200,299]) || (stateno = [400,499])
trigger2 = stateno != 440 ;Except for sweep kick
trigger2 = movecontact
trigger3 = stateno = 131 || stateno = 130 ;From blocking
trigger4 = stateno = 195
var(1) = 1

;---------------------------------------------------------------------------

;-------------------------
[State -1, EX Sakura Rushdown]
type = ChangeState
value = 1320
triggerall = power >= 330
triggerall = command = "EX Sakura Rushdown"
trigger1 = var(1)

[State -1, Light Sakura Rushdown]
type = ChangeState
value = 1300
triggerall = command = "Light Sakura Rushdown"
trigger1 = statetype != A
trigger1 = ctrl
trigger2 = stateno = 130 || stateno = 131

[State -1, Heavy Sakura Rushdown]
type = ChangeState
value = 1310
triggerall = command = "Heavy Sakura Rushdown"
trigger1 = statetype != A
trigger1 = ctrl
trigger2 = stateno = 130 || stateno = 131

;---------------------------------------------------------------------------
[State -1, EX Sakura Upper]
type = ChangeState
value = 1070
triggerall = command = "upper_xy"
triggerall = power >= 330
trigger1 = var(1) ;Use combo condition (above)
trigger2 = stateno = 1000 && movehit
trigger3 = stateno = 1010 && movehit
trigger4 = stateno = 1350 && movehit
trigger5 = stateno = 1410 && movehit && time > 30 && time < 46

;---------------------------------------------------------------------------
[State -1, Light Sakura Upper]
type = ChangeState
value = 1050
triggerall = command = "upper_x"
trigger1 = var(1) ;Use combo condition (above)

;---------------------------------------------------------------------------
[State -1, Strong Sakura Upper]
type = ChangeState
value = 1060
triggerall = command = "upper_y"
trigger1 = var(1) ;Use combo condition (above)

;---------------------------------------------------------------------------
[State -1, EX Sakura Bomb]
type = ChangeState
value = 1020
triggerall = command = "QCF_xy"
triggerall = power >= 330
trigger1 = var(1) ;Use combo condition (above)

;---------------------------------------------------------------------------
[State -1, Light Sakura Bomb]
type = ChangeState
value = 1000
triggerall = command = "QCF_x"
trigger1 = var(1) ;Use combo condition (above)

;---------------------------------------------------------------------------
[State -1, Strong Sakura Bomb]
type = ChangeState
value = 1010
triggerall = command = "QCF_y"
trigger1 = var(1) ;Use combo condition (above)

;---------------------------------------------------------------------------
[State -1, EX Sakura Tornado]
type = ChangeState
value = 1420
triggerall = command = "QCB_ab"
triggerall = power >= 330
trigger1 = var(1) ;Use combo condition (above)

;---------------------------------------------------------------------------
[State -1, Light Sakura Tornado]
type = ChangeState
value = 1400
triggerall = command = "QCB_a"
trigger1 = var(1) ;Use combo condition (above)

;---------------------------------------------------------------------------
[State -1, Strong Sakura Tornado]
type = ChangeState
value = 1410
triggerall = command = "QCB_b"
trigger1 = var(1) ;Use combo condition (above)

;===========================================================================

;Aura Awaken
[State -1, Aura Awaken]
type = null
value = 4000
triggerall = Var(8) != 1
triggerall = power >= 1000
triggerall = command = "Aura Awaken"
trigger1 = statetype != A
trigger1 = ctrl
trigger2 = (Stateno = 150 || Stateno = 151 || Stateno = 1420 || Stateno = 3000)

;---------------------------------------------------------------------------
;Roll Fwd
[State -1, Roll Fwd]
type = ChangeState
value = 1500
triggerall = command != "holdback"
triggerall = (command = "Roll") || (command = "Roll" && command = "holdfwd")
trigger1 = statetype = S
trigger1 = ctrl
trigger1 = Roundstate = 2
trigger2 = (Stateno = 150 || Stateno = 151) && power >= 330

;---------------------------------------------------------------------------
;Roll Back
[State -1, Roll Back]
type = ChangeState
value = 1501
triggerall = command != "holdfwd"
triggerall = (command = "Roll" && command = "holdback")
trigger1 = statetype = S
trigger1 = ctrl
trigger1 = Roundstate = 2
trigger2 = (Stateno = 150 || Stateno = 151) && power >= 330

;---------------------------------------------------------------------------
;Run Fwd
[State -1, Run Fwd]
type = ChangeState
value = 100
trigger1 = command = "FF"
trigger1 = statetype = S
trigger1 = ctrl

;---------------------------------------------------------------------------
;Run Back
[State -1, Run Back]
type = ChangeState
value = 105
trigger1 = command = "BB"
trigger1 = statetype = S
trigger1 = ctrl

;---------------------------------------------------------------------------
;Throw
[State -1, Throw]
type = ChangeState
value = 800
triggerall = (command = "b" && command = "y") || command = "z"
triggerall = stateno != 100
trigger1= statetype = S
trigger1 = ctrl

[State -1, Throw]
type = Null
value = 800
triggerall = (command = "b" && command = "y") || command = "z"
triggerall = statetype = S
triggerall = ctrl
triggerall = stateno != 100
trigger1 = p2bodydist X < 3
trigger1 = (p2statetype = S) || (p2statetype = C)
trigger1 = p2movetype != H
trigger2 = command = "holdback"
trigger2 = p2bodydist X < 5
trigger2 = (p2statetype = S) || (p2statetype = C)
trigger2 = p2movetype != H

;===========================================================================
;Stand Light Punch
[State -1, Stand Light Punch]
type = ChangeState
value = 200
triggerall = command = "x"
triggerall = command != "holddown"
trigger1 = statetype = S
trigger1 = ctrl
trigger2 = stateno = 200
trigger2 = time > 6

;---------------------------------------------------------------------------
;Stand Strong Punch Combo
[State -1, Stand Strong Punch]
type = ChangeState
value = 210
triggerall = command = "y"
trigger1 = stateno = 200 && movehit

;---------------------------------------------------------------------------
;Stand Strong Punch
[State -1, Stand Strong Punch]
type = ChangeState
value = 210
triggerall = command = "y"
triggerall = command != "holddown"
trigger1 = statetype = S
trigger1 = ctrl
trigger2 = (stateno = 200) && time > 5
trigger3 = (stateno = 230) && time > 6

;---------------------------------------------------------------------------
;Stand Light Kick
[State -1, Stand Light Kick]
type = ChangeState
value = 230
triggerall = command = "a"
triggerall = command != "holddown"
trigger1 = statetype = S
trigger1 = ctrl
trigger2 = (stateno = 200) && time > 7
trigger3 = (stateno = 230) && time > 9

;---------------------------------------------------------------------------
;Standing Strong Kick
[State -1, Standing Strong Kick]
type = ChangeState
value = 240
triggerall = command = "b"
triggerall = command != "holddown"
trigger1 = statetype = S
trigger1 = ctrl
trigger2 = (stateno = 200) && time > 5
trigger3 = (stateno = 230) && time > 5

;---------------------------------------------------------------------------
;Taunt
[State -1, Taunt]
type = Null
value = 195
triggerall = command = "start"
trigger1 = statetype != A
trigger1 = ctrl

;---------------------------------------------------------------------------
;Crouching Light Punch
[State -1, Crouching Light Punch]
type = ChangeState
value = 400
triggerall = command = "x"
triggerall = command = "holddown"
trigger1 = statetype = C
trigger1 = ctrl

;---------------------------------------------------------------------------
;Crouching Strong Punch
[State -1, Crouching Strong Punch]
type = ChangeState
value = 410
triggerall = command = "y"
triggerall = command = "holddown"
trigger1 = statetype = C
trigger1 = ctrl
trigger2 = (stateno = 400) || (stateno = 430)
trigger2 = (time > 9) || (movecontact && time > 5)

;---------------------------------------------------------------------------
;Crouching Light Kick
[State -1, Crouching Light Kick]
type = ChangeState
value = 430
triggerall = command = "a"
triggerall = command = "holddown"
trigger1 = statetype = C
trigger1 = ctrl
trigger2 = (stateno = 400) || (stateno = 430)
trigger2 = (time > 9) || (movecontact && time > 5)

;---------------------------------------------------------------------------
;Crouching Strong Kick
[State -1, Crouching Strong Kick]
type = ChangeState
value = 440
triggerall = command = "b"
triggerall = command = "holddown"
trigger1 = statetype = C
trigger1 = ctrl
trigger2 = (stateno = 400) || (stateno = 430)
trigger2 = (time > 9) || (movecontact && time > 5)

;---------------------------------------------------------------------------
;Jump Light Punch
[State -1, Jump Light Punch]
type = ChangeState
value = 600
triggerall = command = "x"
trigger1 = statetype = A
trigger1 = ctrl

;---------------------------------------------------------------------------
;Jump Strong Punch
[State -1, Jump Strong Punch]
type = ChangeState
value = 610
triggerall = command = "y"
trigger1 = statetype = A
trigger1 = ctrl
trigger2 = stateno = 600 || stateno = 630 ;jump_x or jump_a
trigger2 = movecontact

;---------------------------------------------------------------------------
;Jump Light Kick
[State -1, Jump Light Kick]
type = ChangeState
value = 630
triggerall = command = "a"
trigger1 = statetype = A
trigger1 = ctrl

;---------------------------------------------------------------------------
;Jump Strong Kick
[State -1, Jump Strong Kick]
type = ChangeState
value = 640
triggerall = command = "b"
trigger1 = statetype = A
trigger1 = ctrl
trigger2 = stateno = 600 || stateno = 630 ;jump_x or jump_a
trigger2 = movecontact



